src/config/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static

from students.views import index

urlpatterns = [
    path("__debug__/", include("debug_toolbar.urls")),
    path("", index, name="index"),
    path("admin/", admin.site.urls),
    path("students/", include("students.urls")),
    path("teachers/", include("teachers.urls")),
    path("groups/", include("groups.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

src/students/urls.py
from django.urls import path
from students.views import get_students, create_student, update_student, delete_student


app_name = "students"

urlpatterns = [
    path("", get_students, name="all_students"),
    path("create/", create_student, name="create_student"),
    path("update/<int:pk>/", update_student, name="update_student"),
    path("delete/<int:pk>/", delete_student, name="delete_student"),
]

src/students/models.py
import datetime
import random

from django.db import models
from faker import Faker

from groups.models import Group
from main.models import Person, cv_upload_path, avatar_upload_path


class Student(Person):
    grade = models.PositiveSmallIntegerField(null=True, blank=True)
    group = models.ForeignKey(Group, on_delete=models.CASCADE, related_name="students")
    avatar = models.ImageField(upload_to=avatar_upload_path, null=True, blank=True)
    cv = models.FileField(upload_to=cv_upload_path, null=True, blank=True)

    @classmethod
    def generate_instances(cls, count):
        fake = Faker()
        for _ in range(count):
            cls.objects.create(
                first_name=fake.first_name(),
                last_name=fake.last_name(),
                email=fake.email(),
                birth_date=fake.date_of_birth(minimum_age=18, maximum_age=60),
                group=Group.objects.get(id=random.randint(1, 40)),
            )

    def age(self):
        return datetime.datetime.now().year - self.birth_date.year

    def __str__(self):
        return f"{self.first_name} {self.last_name} {self.email} ({self.pk})"

src/students/forms.py
from django.core.exceptions import ValidationError
from django.forms import ModelForm

from students.models import Student


class StudentForm(ModelForm):
    class Meta:
        model = Student
        fields = [
            "first_name",
            "last_name",
            "email",
            "group",
            "avatar",
            "cv",
        ]

    @staticmethod
    def normalize_text(text: str) -> str:
        return text.strip().capitalize()

    def clean_email(self):
        email = self.cleaned_data["email"]

        if "@yandex" in email.lower():
            raise ValidationError("Yandex is not a valid email address!!!")
        return email

    def clean_last_name(self):
        return self.normalize_text(self.cleaned_data["last_name"])

    def clean_first_name(self):
        return self.normalize_text(self.cleaned_data["first_name"])

    def clean(self):
        cleaned_data = super().clean()

        first_name = cleaned_data["first_name"]
        last_name = cleaned_data["last_name"]

        if first_name == last_name:
            raise ValidationError("First name and last name cannot be equal!")

        return cleaned_data

    def clean_cv(self):
        cv = self.cleaned_data.get("cv")
        if cv:
            file_extension = cv.name.split(".")[-1].lower()
            allowed_extensions = ["pdf", "doc", "docx"]
            if file_extension not in allowed_extensions:
                raise ValidationError("Only PDF and DOC files are allowed.")
        return cv

src/students/views.py
from django.db.models import Q
from django.http import HttpResponseRedirect
from webargs import fields
from webargs.djangoparser import use_args

from students.forms import StudentForm
from students.models import Student
from django.shortcuts import get_object_or_404, render
from django.urls import reverse


def index(request):
    return render(request, template_name="index.html", context={"key": "Oleksandra"})


@use_args(
    {
        "first_name": fields.Str(
            required=False,
        ),
        "last_name": fields.Str(
            required=False,
        ),
        "search": fields.Str(
            required=False,
        ),
    },
    location="query",
)
def get_students(request, params):
    students = Student.objects.all()

    search_fields = ["first_name", "last_name", "email"]

    for param_name, param_value in params.items():
        if param_name == "search":
            or_filter = Q()
            for field in search_fields:
                or_filter |= Q(**{f"{field}__icontains": param_value})
            students = students.filter(or_filter)
        else:
            students = students.filter(**{param_name: param_value})

    return render(request, template_name="students/student_list.html", context={"students": students})


def create_student(request):
    if request.method == "POST":
        form = StudentForm(request.POST, request.FILES)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect(reverse("students:all_students"))
    elif request.method == "GET":
        form = StudentForm()

    return render(request, template_name="students/student_create.html", context={"form": form})


def update_student(request, pk):
    student = get_object_or_404(Student.objects.all(), pk=pk)
    if request.method == "POST":
        form = StudentForm(request.POST, request.FILES, instance=student)
        if form.is_valid():
            form.save()
            return HttpResponseRedirect(reverse("students:all_students"))
    elif request.method == "GET":
        form = StudentForm(instance=student)

    return render(request, template_name="students/student_update.html", context={"form": form})


def delete_student(request, pk):
    student = get_object_or_404(Student.objects.all(), pk=pk)
    if request.method == "POST":
        student.delete()
        return HttpResponseRedirect(reverse("students:all_students"))
    elif request.method == "GET":
        pass

    return render(request, template_name="students/student_delete.html", context={"student": student})

src/templates/students/student_create.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <form method="post" enctype="multipart/form-data" style="width: 25em; margin: auto">
            {% csrf_token %}
            {{ form|crispy }}
            <br>
            <button type="submit" class="btn btn-primary" value="Submit">Submit</button>
        </form>
    </div>
{% endblock content %}

src/templates/students/student_delete.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <form method="post" style="width: 25em; margin: auto">
            {% csrf_token %}
            <p> Student {{ student.first_name }} {{ student.last_name }} will be deleted.</p>
            <br>
            <button type="submit" class="btn btn-danger" value="Delete">Delete</button>
        </form>
    </div>
{% endblock content %}

src/templates/students/student_list.html
{% extends "index.html" %}
{% load crispy_forms_filters %}
{% load static %}

{% block content %}
    <div>
        <table class="table table-dark table-striped">
            <thead>
            <tr>
                <th scope="col">Avatar</th>
                <th scope="col">First name</th>
                <th scope="col">Last name</th>
                <th scope="col">Email</th>
                <th scope="col">Birth date</th>
                <th scope="col">Age</th>
                <th scope="col">Grade</th>
                <th scope="col">CV</th>
            </tr>
            </thead>
            <tbody>
            {% for student in students %}
                <tr>
                    {% if student.avatar %}
                        <td><img src="{{ student.avatar.url }}" alt="Avatar" width="30" height="30"></td>
                    {% else %}
                         <td><img alt="Default avatar" src="{% static "img/default_avatar.png" %}" width="30" height="30"></td>
                    {% endif %}
                    <td>{{ student.first_name }}</td>
                    <td>{{ student.last_name }}</td>
                    <td>{{ student.email }}</td>
                    {% if student.birth_date %}
                        <td>{{ student.birth_date }}</td>
                        <td>{{ student.age }}</td>
                    {% else %}
                        <td>Not available</td>
                        <td>Invalid birth date</td>
                    {% endif %}
                    <td>{{ student.grade }}</td>
                    {% if student.cv %}
                        <td><a href="{{ student.cv.url }}">CV</a></td>
                    {% else %}
                        <td>No CV available.</td>
                    {% endif %}
                    <th>
                        <a type="button" class="btn btn-warning" href="{% url "students:update_student" student.pk %}">Edit</a>
                    </th>
                    <th>
                        <a type="button" class="btn btn-danger" href="{% url "students:delete_student" student.pk %}">Delete</a>
                    </th>
                </tr>
            {% endfor %}
            </tbody>
        </table>
    </div>
{% endblock content %}


{% block header %}
<a class="nav-link" href="{% url 'students:create_student' %}">Add new student</a>
{% endblock header %}

src/templates/students/student_update.html
{% extends "index.html" %}
{% load crispy_forms_filters %}

{% block content %}
    <div>
        <form method="post" enctype="multipart/form-data" style="width: 25em; margin: auto">
            {% csrf_token %}
            {{ form|crispy }}
            <br>
            <button type="submit" class="btn btn-primary" value="Update">Update</button>
        </form>
    </div>
{% endblock content %}